#ifndef ENV_H
#define ENV_H
#include "types.h"

struct data_item {
	char * key;
	struct scm_value * value;
	struct data_item * next;
};

typedef struct scm_env {
	struct scm_env * parent;
	union {
		struct data_item * list;
		struct data_item ** hash;
	} items;
	unsigned int capacity;
	unsigned int size;
	unsigned int hash_size;
	unsigned char closure;
	unsigned long last_drop;
} scm_env;

scm_env * scm_env_new(scm_env * parent, unsigned int initial_capacity);
scm_env * scm_env_new_with_hash(scm_env * parent, unsigned int hash_size);
void scm_env_add(scm_env * env, char * key, struct scm_value * value);
struct scm_value * scm_env_get(scm_env * env, char * key);
unsigned long scm_env_get_owner_id(scm_env * env, char * key);
struct scm_value * scm_env_set(scm_env * env, char * key, struct scm_value * value);
void scm_env_recycle(scm_env * env);
void scm_env_print(scm_env * env);
char ** scm_env_get_symbols(scm_env * env);
#endif
