#ifndef RT_H
#define RT_H

#include "mutex.h"
#include "types.h"
#include "env.h"

struct scm_vm;
struct scm_rt;
struct command;


typedef void (*scm_scheduler)(struct scm_rt * rt, struct scm_vm * vm);

struct thread_log {
	int count;
	long us;
	long sec;
	struct thread_log * next;
};

typedef struct scm_rt {
	scm_env * env;
	struct scm_vm * main_vm;
	mutex_t lock;
	short sched_count;
	unsigned short max_threads;
	unsigned int scheduler_limit;
	unsigned int reopen_limit;
	unsigned long last_drop;
	unsigned long last_id;
	struct thread_log * log;
	scm_scheduler scheduler;
} scm_rt;


scm_rt * rt_new(unsigned short max_threads, scm_scheduler scheduler);
scm_value * rt_eval(scm_rt * rt, scm_value * value);
scm_value * rt_eval_str(scm_rt * rt, char * str);
void rt_schedule_fevals(scm_rt * rt, struct scm_vm * vm);
void rt_lock(scm_rt * rt);
void rt_unlock(scm_rt * rt);
void rt_log(scm_rt * rt);

void backward_scheduler(scm_rt * rt, struct scm_vm * vm);
void forward_scheduler(scm_rt * rt, struct scm_vm * vm);
#endif
