(define (matrix-create n value)
  (define (iter m v)
    (if (= m 0) () (cons v (iter (- m 1) v))))
  (iter n (iter n value)))

(define (matrix-get-row m r)
  (if (= r 0) (car m) (matrix-get-row (cdr m) (- r 1)))) 

(define (matrix-get m r c)
  (list-ref (list-ref m r) c))

(define (add m n)
  (define (add-rows r1 r2)
    (if (null? r1) r1
      (cons (+ (car r1) (car r2)) (add-rows (cdr r1) (cdr r2)))))
  (define (iter-row m n)
    (if (null? m) m
      (cons (add-rows (car m) (car n)) (iter-row (cdr m) (cdr n)))))
  (iter-row m n))

(define SIZE 1000)
(define A (matrix-create SIZE 1))
(define B (matrix-create SIZE 4))
(add A B)

