(define (merge-sort items)
  (define (merge-lists s1 s2)
    (cond
      ((and (null? s1) (null? s2)) ())
      ((null? s1) (cons (car s2) (merge-lists s1 (cdr s2))))
      ((null? s2) (cons (car s1) (merge-lists (cdr s1) s2)))
      ((< (car s1) (car s2)) (cons (car s1) (merge-lists (cdr s1) s2))) 
      (#t (cons (car s2) (merge-lists s1 (cdr s2)))))) 

  (define (merge-phase* s)
    (if (null? s) s
      (if (null? (cdr s)) (cons s ())
	(cons (cons (car s) (cadr s)) (merge-phase* (cddr s))))))

  (define (merge-phase s)
    (map-exp (lambda (x) (merge-lists (car x) (cdr x))) s))

  (define (run lists)
    (if (= (length lists) 1) (car lists)
      (run (merge-phase (merge-phase* lists)))))
  (run (map list items)))

(define (random-list len)
  (define (generate len p q s result)
    (if (= len 0) result
      (let ((value (modulo (* s s) (* p q))))
	(generate (- len 1) p q value (cons value result)))))
  (generate len 101 17 3 ()))

(merge-sort (random-list 5000))

