;; http://en.literateprograms.org/Merge_sort_(Scheme)
(define (reverse ls)
  (define (iter source target)
    (if (null? source) target
      (iter (cdr source) (cons (car source) target))))
  (iter ls ()))

(define (split ls)
  (define (split-h ls ls1 ls2)
    (if (or (null? ls) (null? (cdr ls))) (cons (reverse ls2) ls1)
      (split-h (cddr ls)
		     (cdr ls1) (cons (car ls1) ls2))))
  (split-h ls ls ()))

(define merge
  (lambda (pred ls1 ls2)
    (cond
      ((null? ls1) ls2)
      ((null? ls2) ls1)
      ((pred (car ls1) (car ls2))
       (cons (car ls1) (merge pred (cdr ls1) ls2)))
      (#t (cons (car ls2) (merge pred ls1 (cdr ls2)))))))

(define merge-sort
  (lambda (pred ls)
    (cond
      ((null? ls) ls)
      ((null? (cdr ls)) ls)
      (#t (let ((splits (split ls)))
	      (merge pred
		     (merge-sort pred (car splits))
		     (merge-sort pred (cdr splits))))))))

(define (random-list len)
    (define (generate len p q s result)
          (if (= len 0) result
	          (let ((value (modulo (* s s) (* p q))))
		            (generate (- len 1) p q value (cons value result)))))
      (generate len 101 17 3 ()))

(merge-sort < (random-list 10000))
