#!/bin/bash

./sched.py b-sched-fib33-backward.dat > c-sched-fib33-backward.dat
./sched.py b-sched-fib33-forward.dat > c-sched-fib33-forward.dat
./sched.py b-sched-qsort-forward.dat > c-sched-qsort-forward.dat
./sched.py b-sched-qsort-backward.dat > c-sched-qsort-backward.dat
./sched.py b-real-mergesort-backward.dat > c-real-mergesort-backward.dat
./sched.py b-real-matrix1-backward.dat > c-real-matrix1-backward.dat
./sched.py b-real-matrix2-backward.dat > c-real-matrix2-backward.dat
./sched.py b-real-matrix3-backward.dat > c-real-matrix3-backward.dat
./sched.py b-real-bubblesort-backward.dat > c-real-bubblesort-backward.dat
./sched.py b-platf-holly-backward.dat 4 > c-platf-holly-backward.dat
./sched.py b-platf-homer-backward.dat 4 > c-platf-homer-backward.dat
./sched.py b-platf-zababa-backward.dat 2 > c-platf-zababa-backward.dat
./sched.py b-platf-phoenix-backward.dat 2 > c-platf-phoenix-backward.dat

cat c-sched-fib33-backward.dat | ./textab.sh > d-sched-fib33-backward.tex
cat c-sched-fib33-forward.dat | ./textab.sh > d-sched-fib33-forward.tex
gnuplot "sched-fib33.gp"
mpost "e-sched-fib33.mp"
mv "e-sched-fib33.0" "f-sched-fib33.mps"

cat c-sched-qsort-backward.dat | ./textab.sh > d-sched-qsort-backward.tex
cat c-sched-qsort-forward.dat | ./textab.sh > d-sched-qsort-forward.tex
gnuplot "sched-qsort.gp"
mpost "e-sched-qsort.mp"
mv "e-sched-qsort.0" "f-sched-qsort.mps"

cat c-real-mergesort-backward.dat | ./textab.sh > d-real-mergesort-backward.tex
cat c-real-bubblesort-backward.dat | ./textab.sh > d-real-bubblesort-backward.tex
cat c-real-matrix1-backward.dat | ./textab.sh > d-real-matrix1-backward.tex
cat c-real-matrix2-backward.dat | ./textab.sh > d-real-matrix2-backward.tex
cat c-real-matrix3-backward.dat | ./textab.sh > d-real-matrix3-backward.tex

gnuplot "threads-quicksort-forward.gp"
mpost "e-threads-quicksort-forward.mp"
mv "e-threads-quicksort-forward.0" "f-threads-quicksort-forward.mps"

gnuplot "threads-quicksort-backward.gp"
mpost "e-threads-quicksort-backward.mp"
mv "e-threads-quicksort-backward.0" "f-threads-quicksort-backward.mps"

gnuplot "threads-fib33-forward.gp"
mpost "e-threads-fib33-forward.mp"
mv "e-threads-fib33-forward.0" "f-threads-fib33-forward.mps"

gnuplot "threads-fib33-backward.gp"
mpost "e-threads-fib33-backward.mp"
mv "e-threads-fib33-backward.0" "f-threads-fib33-backward.mps"


cat c-platf-holly-backward.dat | ./textab.sh > d-platf-holly-backward.tex
cat c-platf-homer-backward.dat | ./textab.sh > d-platf-homer-backward.tex
cat c-platf-phoenix-backward.dat | ./textab.sh > d-platf-phoenix-backward.tex
cat c-platf-zababa-backward.dat | ./textab.sh > d-platf-zababa-backward.tex

rm c-*.dat
rm e-*
