#!/usr/bin/python

import sys

maximumCores = 4

# reads data from source
try:
	inputFileName = sys.argv[1]
	if (len(sys.argv) == 3): maximumCores = int(sys.argv[2])
except:
	print "missing input file name"
	sys.exit(1)

inp = open(inputFileName, "r")
rawData = []

while inp:
	s = inp.readline()
	if (len(s) == 0): break
	rawData.append(s.split("\t"))

# calculate averages
sum = {}
for item in rawData:
	threadCount = int(item[0].strip())
	time = float(item[1].strip())
	if not sum.has_key(threadCount):
		sum[threadCount] = (time, 1)
	else:
		sum[threadCount] = (sum[threadCount][0] + time, sum[threadCount][1] +1)

avgs = {}
for item in sum:
	avgs[item] = sum.get(item)[0] / sum.get(item)[1]
		

# calculate results
single = avgs.get(0)
for item in avgs:
	count = item
	avg = avgs.get(item)
	if (count >= maximumCores): usedCores = maximumCores
	else: usedCores = count + 1

	optimal = single / usedCores;
	overhead = 1 - (optimal / avg); 
	perCoreOverhead = overhead / usedCores; 

	improvement = (single / avg) - 1
	perCoreImprovement = improvement / usedCores


	print "%i\t%.2f\t%i\t%.2f\t%.2f\t%.2f\t%.2f\t%.2f" % (count + 1, avg, usedCores, improvement * 100, perCoreImprovement * 100, optimal, overhead * 100, perCoreOverhead * 100)



